//#include <math.h>
/*http://en.wikipedia.org/wiki/Garbage_collection_%28computer_science%29*/
/*http://en.wikipedia.org/wiki/Free_list*/

#define NULE 0
#define MULE 8888

typedef struct NOIDEA_memory
{
	int id;
	int size;
	struct NOIDEA_memory * last;
	struct NOIDEA_memory * next;
} NOIDEA_memory;

typedef struct NOIDEA_yromem
{
	NOIDEA_memory * space;
	int id;
} NOIDEA_yromem;

/*after reading in wikipedia , i found similarity with Garbage Collection by John McCarthy*/
/*so i've invented nothing*/

/*give an array or a malloc to this function */
NOIDEA_memory * NOIDEA_seg (void * noidea_array, int noidea_size)
{

	NOIDEA_memory * noidea_header = (NOIDEA_memory*)noidea_array;
	NOIDEA_memory * noidea_new = (NOIDEA_memory*)(noidea_array + sizeof(NOIDEA_memory));
	NOIDEA_yromem * noidea_ender = (NOIDEA_yromem*)(noidea_array + noidea_size - sizeof(NOIDEA_yromem));
	noidea_header->id = MULE;
	noidea_header->size = noidea_size;
	noidea_header->last = noidea_new;
	noidea_header->next = noidea_new;
	noidea_new->id = MULE;
	noidea_new->size = noidea_size - sizeof(NOIDEA_memory);
	noidea_new->last = noidea_header;
	noidea_new->next = noidea_header;
	noidea_ender->space = noidea_header;
	noidea_ender->id = MULE;
	return noidea_header;
}

void * NOIDEA_alloc (NOIDEA_memory * noidea_segment, int noidea_size)
{
	if (noidea_size < sizeof(NOIDEA_memory)+sizeof(NOIDEA_yromem))
	{
		noidea_size = sizeof(NOIDEA_memory)+sizeof(NOIDEA_yromem);
	}
	NOIDEA_memory * noidea_pivot = noidea_segment->next;
	NOIDEA_memory * noidea_enogh;
	while (noidea_pivot != noidea_segment)
	{
		if (noidea_pivot->size - sizeof(NOIDEA_memory) > noidea_size + sizeof(int))
		{
			noidea_enogh = noidea_pivot;
			noidea_pivot = noidea_segment->last;
		}
		noidea_pivot = noidea_pivot->next;
	}

	if (noidea_enogh != 0)
	{
		NOIDEA_memory * noidea_mov = (NOIDEA_memory*)((void*)noidea_enogh + noidea_size + sizeof(int));
		NOIDEA_yromem * noidea_set = (NOIDEA_yromem*)((void*)noidea_enogh + noidea_enogh->size - sizeof(NOIDEA_yromem));
		void * noidea_new = (void*) noidea_enogh;

		noidea_mov->id = noidea_enogh->id;
		noidea_mov->size = noidea_enogh->size - noidea_size - sizeof(int);
		noidea_mov->last = noidea_enogh->last;
		noidea_mov->next = noidea_enogh->next;
		noidea_mov->last->next = noidea_mov;
		noidea_mov->next->last = noidea_mov;

		noidea_set->space = noidea_mov;
		*(int*)noidea_new = noidea_size;
		noidea_new = noidea_new +sizeof(int);

		//debug debug debug debug debug debug
		*(int*)noidea_new = 0;
		*(int*)(noidea_new + sizeof(int)) = 0;
		*(int*)(noidea_new + (sizeof(int) * 2)) = 0;
		//debug debug debug debug debug debug

		return noidea_new;
	}
	return NULE;
}

void NOIDEA_free (NOIDEA_memory * noidea_segment, void * noidea_offset)
{
	int noidea_size = *(int*)(noidea_offset - sizeof(int));
	NOIDEA_memory * noidea_new = (NOIDEA_memory*) (noidea_offset - sizeof(int));
	NOIDEA_yromem * noidea_end = (NOIDEA_yromem*) (noidea_offset + noidea_size - sizeof(NOIDEA_yromem));
	noidea_new->id = MULE;
	noidea_new->size = noidea_size + sizeof(int);
	noidea_new->last = noidea_segment;
	noidea_new->next = noidea_segment->next;
	noidea_new->last->next = noidea_new;
	noidea_new->next->last = noidea_new;
	noidea_end->id = MULE;
	noidea_end->space = noidea_new;
	if ((*(int*)(noidea_offset + noidea_size)) == MULE )
	{

		NOIDEA_memory * noidea_forward = (NOIDEA_memory*)(noidea_offset + noidea_size);
		NOIDEA_yromem * noidea_foreend = (NOIDEA_yromem*)((void*)noidea_forward + noidea_forward->size - sizeof(NOIDEA_yromem));
		noidea_new->size = noidea_new->size + noidea_forward->size;
		noidea_forward->next->last = noidea_forward->last;
		noidea_forward->last->next = noidea_forward->next;
		noidea_foreend->space = noidea_new;
		//debug
		noidea_end->id = 0;
		noidea_end->space = 0;
		noidea_forward->id = 0;
		noidea_forward->size = 0;
		noidea_forward->last = 0;
		noidea_forward->next = 0;
		//debug
		noidea_end = noidea_foreend;
	}
	if ((*(int*)(noidea_offset - (sizeof(int)*2))) == MULE )
	{
		NOIDEA_yromem * noidea_backend = (NOIDEA_yromem*)(noidea_offset - (sizeof(int)*2) - sizeof(void*));
		NOIDEA_memory * noidea_bacward = noidea_backend->space;

		noidea_bacward->size = noidea_bacward->size + noidea_new->size;
		noidea_new->next->last = noidea_new->last;
		noidea_new->last->next = noidea_new->next;
		noidea_end->space = noidea_bacward;
		//debug
		noidea_backend->id = 0;
		noidea_backend->space = 0;
		noidea_new->id = 0;
		noidea_new->size = 0;
		noidea_new->last = 0;
		noidea_new->next = 0;
		//debug
		noidea_new = noidea_bacward;
	}
}

//================================================================================
//================================================================================
//================================================================================

/*http://en.wikipedia.org/wiki/Linked_list*/


typedef struct NOIDEA_node
{
	void * pack;
	struct NOIDEA_node * last;
	struct NOIDEA_node * next;
} NOIDEA_node;

NOIDEA_node * NOIDEA_create (NOIDEA_node * noidea_src, void * noidea_pack, void * noidea_ptr)
{
	if (noidea_ptr == 0)
	{	return 0;	}

	NOIDEA_node * noidea_nud = (NOIDEA_node*) noidea_ptr;
	noidea_nud->pack = noidea_pack;

	if (noidea_src != 0)
	{
		noidea_nud->last = noidea_src;
		noidea_nud->next = noidea_src->next;
		noidea_nud->last->next = noidea_nud;
		noidea_nud->next->last = noidea_nud;
	}
	else
	{
		noidea_nud->last = noidea_nud;
		noidea_nud->next = noidea_nud;
	}

	return noidea_nud;
}

void * NOIDEA_destroy (NOIDEA_node * noidea_src, NOIDEA_node * noidea_nud)
{
	if ((noidea_src == 0)||(noidea_nud == 0))
	{	return;		}

	if (noidea_src == noidea_nud)
	{
		//you shouldnt destroy sentinel if array is not empty
			if (noidea_src != noidea_src->next)
			{
				return;
			}
	}

	noidea_nud->last->next = noidea_nud->next;
	noidea_nud->next->last = noidea_nud->last;

	noidea_nud->pack = 0;
	noidea_nud->last = 0;
	noidea_nud->next = 0;

	return (void*) noidea_nud;	//return ptr in case of alloc/free
}

void * NOIDEA_loop (NOIDEA_node * noidea_src)
/* all node will move around noidea_src */
/* so its sure that youll get them all */
{
	NOIDEA_node * noidea_nud = noidea_src->next;

	noidea_src->last->next = noidea_src->next;
	noidea_src->next->last = noidea_src->last;

	noidea_nud->next->last = noidea_src;
	noidea_src->next = noidea_nud->next;

	noidea_nud->next = noidea_src;
	noidea_src->last = noidea_nud;


	return noidea_nud->pack;
}


//================================================================================
//================================================================================
//================================================================================



typedef struct NOIDEA_agenda
{
	signed long int wait;		//interval between call
	void (*func)(void);		//function to call
	signed long int till;		//wait till to execute
	signed long int idle;		//time left before execute
	signed long int loop;		//value that end loop
	NOIDEA_node * node;		//the node that list it
} NOIDEA_agenda;


NOIDEA_node * NOIDEA_schedule (NOIDEA_node * noidea_sentinel, void (*noidea_func)(void), signed long int noidea_wait ,void * noidea_ptr)
{
	NOIDEA_agenda * noidea_now = (NOIDEA_agenda*) noidea_ptr;
	NOIDEA_node * noidea_node_now = NOIDEA_create(noidea_sentinel,noidea_now,noidea_ptr + sizeof(NOIDEA_agenda));
	noidea_now->node = noidea_node_now;
	noidea_now->func = noidea_func;
	noidea_now->wait = noidea_wait;

	return noidea_node_now;
}

void * NOIDEA_cancel (NOIDEA_node * noidea_node_today, NOIDEA_node * noidea_node_now)
{
	NOIDEA_agenda * noidea_now = noidea_node_now->pack;
	noidea_now->wait = 0;
	noidea_now->func = 0;
	noidea_now->idle = 0;
	noidea_now->till = 0;
	noidea_now->loop = 0;
	noidea_now->node = 0;
	noidea_node_now = NOIDEA_destroy (noidea_node_today, noidea_node_now);
	return ((void*)noidea_now);
}

signed long int NOIDEA_do (NOIDEA_node * noidea_sentinel, signed long int noidea_time)
{
		NOIDEA_agenda * noidea_today = (NOIDEA_agenda*)noidea_sentinel->pack;
		NOIDEA_agenda * noidea_now;
		noidea_today->loop += 1;
		noidea_today->idle = noidea_today->wait;
		int noidea_yet = 0;
		while (noidea_yet != 1)
		{

			noidea_now = NOIDEA_loop(noidea_sentinel);
			if (noidea_now->loop == noidea_today->loop)
			{
				noidea_yet = 1;
			}
			

			if (noidea_now->till == 0)
			{
				noidea_now->till = noidea_time + noidea_now->wait;
			}
			if (noidea_now->till <= noidea_time)
			{
				noidea_now->till = noidea_time + noidea_now->wait;
				noidea_now->idle = 0;
				noidea_now->func();
				noidea_yet = 1;
			}
			else
			{
				noidea_now->idle = noidea_now->till - noidea_time;
				noidea_now->loop = noidea_today->loop;
			}
			if (noidea_now->idle < noidea_today->idle)
			{
				noidea_today->idle = noidea_now->idle;
			}
		}
	return noidea_today->idle;
}

//================================================================================
//================================================================================
//================================================================================
//==============================the object========================================
//================================================================================
//================================================================================
//================================================================================

typedef struct noidea_env
{
	void * self;

	NOIDEA_memory * env;
	void * (*alloc)(struct noidea_env*,int);
	void (*free) (struct noidea_env * , void * );

	NOIDEA_node * list;
	NOIDEA_node * (*append) (struct noidea_env * ,int);
	void (*remove) (struct noidea_env * ,NOIDEA_node*);
	void * (*next) (struct noidea_env * );

	NOIDEA_node * thread;
	NOIDEA_node * (*start) (struct noidea_env * ,void (*)(void),signed long int);
	void (*stop) (struct noidea_env * , NOIDEA_node *);
	signed long int (*loop) (struct noidea_env *, signed long int );

}noidea_env;
void * noidea_alloc(noidea_env* noidea_self,int size){	return NOIDEA_alloc(noidea_self->env,size);}
void noidea_free(noidea_env* noidea_self, void * ptr){	NOIDEA_free(noidea_self->env,ptr);}

typedef NOIDEA_node noidea_nod;
NOIDEA_node * noidea_append(struct noidea_env * noidea_self ,int noidea_size)
{	void * noidea_mem = noidea_alloc(noidea_self,sizeof(NOIDEA_node)+noidea_size);
	return NOIDEA_create(noidea_self->list,noidea_mem + sizeof(NOIDEA_node),noidea_mem);
}
void noidea_remove(struct noidea_env * noidea_self, NOIDEA_node * noidea_nud){	noidea_free(noidea_self,NOIDEA_destroy(noidea_self->list,noidea_nud));}
void * noidea_next(struct noidea_env * noidea_self){	NOIDEA_loop(noidea_self->list);}

void noidea_rien(void){}
NOIDEA_node * noidea_start (struct noidea_env * noidea_self,void (*noidea_func)(void),signed long int noidea_when){	return NOIDEA_schedule(noidea_self->thread,noidea_func,noidea_when,noidea_alloc(noidea_self,sizeof(NOIDEA_node)+sizeof(NOIDEA_agenda)));}
void noidea_stop (struct noidea_env * noidea_self, NOIDEA_node * noidea_thread){	NOIDEA_free(noidea_self->env,NOIDEA_cancel(noidea_self->thread,noidea_thread));}
signed long int noidea_loop (struct noidea_env * noidea_self, signed long int noidea_now){	return NOIDEA_do(noidea_self->thread,noidea_now);}

noidea_env * noidea_init(void * ptr, int size)
{
	noidea_env * self = (noidea_env*) ptr;
	self->self = self;

	self->env = NOIDEA_seg(ptr + sizeof(noidea_env),size - sizeof(noidea_env));
	self->alloc = noidea_alloc;
	self->free =  noidea_free;

	self->list = NOIDEA_create(0,ptr,noidea_alloc(self,sizeof(NOIDEA_node)));
	self->append = noidea_append;
	self->remove = noidea_remove;
	self->next = noidea_next;

	self->thread = NOIDEA_schedule(0,&noidea_rien,1000000,noidea_alloc(self,sizeof(NOIDEA_node)+sizeof(NOIDEA_agenda)));
	self->start = noidea_start;
	self->stop = noidea_stop;
	self->loop = noidea_loop;

	return self;
}
//================================================================================
//================================================================================
//================================================================================
//==============================the object========================================
//================================================================================
//================================================================================
//================================================================================
//=========================================================================

//-----------------------------------------------------------------------------------------------------------------


char noidea_nibble2hex(int noidea_int)
{
	char noidea_tmp = 0;
	if ((noidea_int>=0)&&(noidea_int<=15))
	{
		if (noidea_int<=9)
		{
			noidea_tmp = (char)(48 + noidea_int);
		}
		else
		{
			noidea_tmp = (char)(65 + noidea_int - 10);
		}
	}
	return noidea_tmp;
}

int noidea_hex2nibble(char noidea_char)
{
	int noidea_tmp = 0;
	if ((noidea_char >= 48)&&(noidea_char <= 57))
	{
		noidea_tmp = (char)(noidea_char - 48);
	}
	if ((noidea_char >= 65)&&(noidea_char <= 70))
	{
		noidea_tmp = (char)(noidea_char - 65);	
	}
	return noidea_tmp;
}

int noidea_getexp(float noidea_float, int noidea_gage)
{
	int noidea_tmp = 0;
	noidea_float = noidea_float - (int)noidea_float;
	while (noidea_float != 0)
	{
		noidea_float = noidea_float * noidea_gage;
		noidea_float = noidea_float - (int)noidea_float;
		noidea_tmp = noidea_tmp + 1;
	}
	return noidea_tmp;
}

int noidea_intpow(int noidea_int, int noidea_pow)
{
	int noidea_tmp = 1;
	while (noidea_pow != 0)
	{
		noidea_tmp = noidea_tmp * noidea_int;
		noidea_pow = noidea_pow - 1;
	}
	return noidea_tmp;
}

int noidea_getsize(int noidea_int,int noidea_gage)
{
	int noidea_tmp = 0;
	while (noidea_int != 0)
	{
		noidea_int = noidea_int / noidea_gage;
		noidea_tmp = noidea_tmp + 1;
	}
	return noidea_tmp;
}

NOIDEA_node * noidea_insert(noidea_env * noidea_self , char * noidea_str)
{
	//get the size of the str
	int noidea_size = 0;
	while (*(noidea_str + noidea_size) != (char)35)
	{
		noidea_size += sizeof(char);
	}
	//readjust size to make sure its void* size
	noidea_size += (sizeof(void*) - (noidea_size % sizeof(void*)));
	//alloc memory node for the str
	NOIDEA_node * noidea_nud = noidea_append(noidea_self, sizeof(char) * noidea_size);
	char * noidea_ptr = noidea_nud->pack;
	//copy the str to the node
	int noidea_tmp = 0;
	while (noidea_tmp <= noidea_size)
	{
		*(noidea_ptr + noidea_tmp) = *(noidea_str + noidea_tmp);
		noidea_tmp += sizeof(char);
	}
	return noidea_nud;
}

char * noidea_extract(NOIDEA_node * noidea_nud)
{
	//build temporary str
	char noidea_tmp[128];
	char * noidea_ptr = noidea_tmp;
	char * noidea_str = noidea_nud->pack;
	//build other temporary var
	int noidea_index = 0;
	//extract
	while (*(noidea_str + noidea_index) != 35)
	{
		*(noidea_ptr + noidea_index) = *(noidea_str + noidea_index);
		noidea_index += sizeof(char);
	}
	return noidea_ptr;
}

char * noidea_float2hex(float noidea_float)
{
	//temporary array
	char noidea_txt[128 * sizeof(char)];
	char * noidea_str = noidea_txt;
	//check the presence of the sign
	int noidea_sign = 0;
	if (noidea_float < 0)
	{
		noidea_sign = 1;
		noidea_float = 0 - noidea_float;
	}
	//check the presence of a floating point
	int noidea_point = 0;
	if (noidea_float - (int)noidea_float != 0)
	{
		noidea_point = 1;
	}
	//get the size of the str
	int noidea_exp = noidea_getexp(noidea_float,16);
	int noidea_int = (int)(noidea_float * noidea_intpow(16, noidea_exp));
	int noidea_size = noidea_getsize((int)noidea_float,16);
	//character termination = 35 "#" 
	*(noidea_str + (sizeof(char) * (noidea_sign+noidea_size+noidea_point+noidea_exp+1))) = (char)35;
	//all hexadecimal below 1
	while (noidea_exp != 0)
	{
		*(noidea_str + (sizeof(char) * (noidea_sign+noidea_size+noidea_point+noidea_exp))) = noidea_nibble2hex(noidea_int % 16);
		noidea_int = noidea_int / 16;
		noidea_exp = noidea_exp - 1;
	}
	//point
	if (noidea_point != 0)
	{
		*(noidea_str + (sizeof(char) * (noidea_sign+noidea_size+noidea_point))) = (char)46;
	}
	//all hexadecimal that remain
	while (noidea_size != 0)
	{
		*(noidea_str + (sizeof(char) * (noidea_sign+noidea_size))) = noidea_nibble2hex(noidea_int % 16);
		noidea_int = noidea_int / 16;
		noidea_size = noidea_size - 1;
	}
	//sign
	if (noidea_sign != 0)
	{
		*(noidea_str + (sizeof(char) * (noidea_sign))) = (char)45;
	}
	//identification character "h" for hexadecimal 104
	*(noidea_str) = (char)104;
	
	return noidea_str;
}

char * noidea_float2bin(float noidea_float)
{
	//temporary array
	char noidea_txt[1024 * sizeof(char)];
	char * noidea_str = noidea_txt;
	//check the presence of the sign
	int noidea_sign = 0;
	if (noidea_float < 0)
	{
		noidea_sign = 1;
		noidea_float = 0 - noidea_float;
	}
	//check the presence of a floating point
	int noidea_point = 0;
	if (noidea_float - (int)noidea_float != 0)
	{
		noidea_point = 1;
	}
	//get the size of the str
	int noidea_exp = noidea_getexp(noidea_float,2);
	int noidea_int = (int)(noidea_float * noidea_intpow(2, noidea_exp));
	int noidea_size = noidea_getsize((int)noidea_float,2);
	//character termination = 35 "#" 
	*(noidea_str + (sizeof(char) * (noidea_sign+noidea_size+noidea_point+noidea_exp+1))) = (char)35;
	//all bit below 1
	while (noidea_exp != 0)
	{
		*(noidea_str + (sizeof(char) * (noidea_sign+noidea_size+noidea_point+noidea_exp))) = noidea_nibble2hex(noidea_int % 2);
		noidea_int = noidea_int / 2;
		noidea_exp = noidea_exp - 1;
	}
	//point
	if (noidea_point != 0)
	{
		*(noidea_str + (sizeof(char) * (noidea_sign+noidea_size+noidea_point))) = (char)46;
	}
	//all hexadecimal that remain
	while (noidea_size != 0)
	{
		*(noidea_str + (sizeof(char) * (noidea_sign+noidea_size))) = noidea_nibble2hex(noidea_int % 2);
		noidea_int = noidea_int / 2;
		noidea_size = noidea_size - 1;
	}
	//sign
	if (noidea_sign != 0)
	{
		*(noidea_str + (sizeof(char) * (noidea_sign))) = (char)45;
	}
	//identification character "d" for hexadecimal 100
	*(noidea_str) = (char)98;
	
	return noidea_str;
}



char * noidea_float2dec(float noidea_float)
{
	//temporary array
	char noidea_txt[128 * sizeof(char)];
	char * noidea_str = noidea_txt;
	//check the presence of the sign
	int noidea_sign = 0;
	if (noidea_float < 0)
	{
		noidea_sign = 1;
		noidea_float = 0 - noidea_float;
	}
	//check the presence of a floating point
	int noidea_point = 0;
	if (noidea_float - (int)noidea_float != 0)
	{
		noidea_point = 1;
	}
	//get the size of the str
}

char * noidea_float2node(NOIDEA_node * noidea_nud, int noidea_format)
{

}

float noidea_node2float(NOIDEA_node * noidea_nud)
{
	char * noidea_str = noidea_nud->pack;
	int noidea_format;
	int noidea_index = 0;
	int noidea_int = 0;
	float noidea_flt = 0;
	int noidea_tmp;
	//make sure its a bin type
	if ((*(noidea_str + noidea_index) != 98)&&(*(noidea_str + noidea_index) != 104)&&(*(noidea_str + noidea_index) != 100))
	{
		return 0;
	}
	if (*(noidea_str + noidea_index) == 98)
	{
		noidea_format = 2;
	}
	if (*(noidea_str + noidea_index) == 104)
	{
		noidea_format = 16;
	}
	if (*(noidea_str + noidea_index) == 100)
	{
		noidea_format = 10;
	}
	noidea_index += sizeof(char);
	//get the sign
	int noidea_sign = 0;
	if (*noidea_str == (char)45)
	{
		noidea_sign = 1;
		noidea_index += sizeof(char);
	}
	//get int from str
	while ( (*(noidea_str + noidea_index) != (char)46) && (*(noidea_str + noidea_index) != (char)35) )
	{
		noidea_tmp = noidea_hex2nibble(*(noidea_str + noidea_index));
		noidea_int = noidea_int * noidea_format;
		noidea_int = noidea_int + noidea_tmp;
		noidea_index += sizeof(char);
	}
	//now maybe we got a "."
	int noidea_exp = 0;
	while (*(noidea_str + noidea_index) != 35)
	{
		noidea_tmp = noidea_hex2nibble(*(noidea_str + noidea_index));
		noidea_flt = noidea_flt + (float)noidea_tmp;
		noidea_flt = noidea_flt * noidea_format;
		noidea_exp += 1;
		noidea_index += sizeof(char);
	}
	noidea_flt = noidea_flt / noidea_intpow(noidea_format,noidea_exp);
	//let unite real with float
	noidea_flt += (float)noidea_int;
	if (noidea_sign != 0)
	{
		noidea_flt = 0 - noidea_flt;
	}

	return noidea_flt;
}

int noidea_node2int(NOIDEA_node * noidea_nud)
{
	return (int)noidea_node2float(noidea_nud);
}
